Program Give_change;
{ Works out how many nickels, dimes, quarters and pennies to give }
{ in change (up to 99 cents) }
Uses Crt;
Const
   { Declare value of each coin, for clarity }
   Quarter_value = 25;
   Dime_value = 10;
   Nickel_value = 5;
   Penny_value = 1;
Var
   Change: Integer; { Amount of change requested by user }
   Quarters, Dimes, Nickels, Pennies: Integer; { Count of each coin type }
Begin
ClrScr;

{ Ask the user for the change amount }
Write('How much is the change (up to 99 cents) ? ');
ReadLn(Change);

{ Quarters is the whole part when dividing Change by Quarter_value... }
Quarters := Change div Quarter_value;

{ ...change still to give is the remainder... }
Change := Change mod Quarter_value;

{ ...similarly for dimes... }
Dimes := Change div Dime_value;
Change := Change mod Dime_value;

{ ...similarly for nickels... }
Nickels := Change div Nickel_value;
Change := Change mod Nickel_value;

{ ...what's left are the Pennies. }
Pennies := Change;

{ Print the results (only report used coins) }
If Quarters > 0 Then
   Begin
   WriteLn('Quarters: ', Quarters);
   End;

If Dimes > 0 Then
   Begin
   WriteLn('Dimes:    ', Dimes);
   End;

If Nickels > 0 Then
   Begin
   WriteLn('Nickels:  ', Nickels);
   End;

If Pennies > 0 Then
   Begin
   WriteLn('Pennies:  ', Pennies);
   End

End.
