Program Test_on_screen;
{ Tests the operation of On_screen() }
Uses Crt;
Function On_screen(X, Y: Integer): Boolean;
   { Returns True if the given coordinates are on-screen, }
   { returns False otherwise }
   Const
      { Mark screen dimensions as constants }
      Screen_height = 25;
      Screen_width = 80;
   Var
      X_ok, Y_ok: Boolean; { Test results }
   Begin
      X_ok := (X >= 1) And (X <= Screen_width);    { Is X on-screen? }
      Y_ok := (Y >= 1) And (Y <= Screen_height);   { Is Y on-screen? }
      On_screen := X_ok And Y_ok    { Are the coordinates on-screen? }
   End;
Begin
ClrScr;

{ Test On_screen() for various coordinates by writing }
{ the expected result followed by the actual result }

{ Typical coordinates }
WriteLn('This result should be true: ', On_screen(9,9));
WriteLn('This result should be false: ', On_screen(-10,10));
WriteLn('This result should be false: ', On_screen(11,-11));
WriteLn('This result should be false: ', On_screen(-12,-12));

{ Extreme coordinates }
WriteLn('This result should be true: ', On_screen(1,1));
WriteLn('This result should be true: ', On_screen(1,25));
WriteLn('This result should be true: ', On_screen(80,1));
WriteLn('This result should be true: ', On_screen(80,25));

{ Nearest coordinates off-screen }
WriteLn('This result should be false: ', On_screen(0,0));
WriteLn('This result should be false: ', On_screen(0,26));
WriteLn('This result should be false: ', On_screen(81,0));
WriteLn('This result should be false: ', On_screen(81,26));

End.
