Program Stick;
{ Draws a stick person in the middle of the screen }
Uses Crt;
Const
   { Characters for the head, arms and legs }
   Head_char = 'h';
   Arm_char = 'a';
   Leg_char = 'l';
Var 
   X: Integer;   { For loop index for drawing the arms }
Function On_screen(X, Y: Integer): Boolean;
   { Returns True if the given coordinates are on-screen, }
   { returns False otherwise }
   Const
      { Mark screen dimensions as constants }
      Screen_height = 25;
      Screen_width = 80;
   Var
      X_ok, Y_ok: Boolean; { Test results }
   Begin
      X_ok := (X >= 1) And (X <= Screen_width);    { Is X on-screen? }
      Y_ok := (Y >= 1) And (Y <= Screen_height);   { Is Y on-screen? }
      On_screen := X_ok And Y_ok    { Are the coordinates on-screen? }
   End;
Procedure Draw_char(X, Y: Integer; A_char: Char);
   { Draws the character A_char at the coordinates (X, Y) }
   { Does nothing if the coordinates are off-screen }
   Begin
   If On_screen(X, Y) Then    { Only draw if on-screen }
      Begin
      GotoXY(X, Y);
      Write(A_char)
      End
   End;
Begin
ClrScr;

{ Draw the head }
Draw_char(40, 9, Head_char);
Draw_char(39, 10, Head_char);
Draw_char(41, 10, Head_char);
Draw_char(40, 11, Head_char);

{ Draw the arms }
For X := 37 To 43 Do
   Begin
   Draw_char(X, 12, Arm_char)
   End;

{ Draw the legs }
Draw_char(40, 13, Leg_char);
Draw_char(39, 14, Leg_char);
Draw_char(41, 14, Leg_char);
Draw_char(38, 15, Leg_char);
Draw_char(42, 15, Leg_char);

End.
