
Program Ex_5_3; 		{ A program to guess the user's age in years }
Uses
   Crt;
Const				{ Declare constants }
    maximum_age = 150;		{ Maximum age allowed }
    initial_guess = 75;		{ Initial guess }
Var				{ Declare variables }
   high, low, guess: Integer;	{ For recording state of game }
   response: Char;		{ Key pressed by user }
   continue: Boolean;		{ Controls whether program continues }
Begin
Clrscr;

{Initialize variables }
high := maximum_age;
low := 0;
guess := initial_guess;

{ Display the rules }
WriteLn('I''d like to try and guess your age.');
WriteLn('The rules are:');
WriteLn('   1) I make a guess and you tell me whether it was: ');
WriteLn('        too high or too low or I guessed correctly.');
WriteLn('   2) You''re not older than 150!');
WriteLn('   3) No cheating!!');

{ Ask the user whether they agree to the rules }
Write('Are these rules OK with you? (y/n) ');
response := readkey; 		{ Record key pressed by user }
Clrscr;

{ Set value of continue to true or false according to response}
continue := (response = 'y') or (response = 'Y');

{ While continue is true execute statements between Begin and End }
While continue Do
   Begin

   WriteLn('I guess ', guess:3, '.');	{ Display current guess }

   { Ask user whether guess is correct, too high or too low }
   WriteLn('Please tell me whether:');
   WriteLn('   "c" - I''m correct');
   WriteLn('   "h" - I''m too high');
   WriteLn('   "l" - I''m too low');

   { Select what to do based on user's response }
   response := readkey;
   Case response Of

      'c': { guess is correct }
         Begin
         continue := false;	{ Set continue to false to exit while }
					{ statement }
         { Say goodbye }
		 WriteLn('Thanks for playing. Have a nice day!')
         End;

      'h': { guess is too high }
         Begin
         high := guess;	{ Set high point to current guess }
         guess := (low + guess - 1) div 2;	{ Make new guess }
         End;
      'l': { guess is too low }
         Begin
         low := guess;	{ Set low point to current guess }
         guess := (guess + high + 1) div 2;	{ Make new guess }
         End;

      End; { Case }
   WriteLn;
   End { While. Goes back to while statement to check continue }
End.
