
Program Ex_5_8; { Asks the user to enter a date until they get it right }
Uses Crt;
Var
   day, month, year: LongInt;                   { Day, month and year }
                                                { entered by user }
   valid_day, valid_month, valid_year: Boolean; { For recording whether }
                                                { input is valid }
   century_year, leap_year: Boolean;            { For recording whether }
                                                { year is a century year }
                                                { and/or a leap year }

Begin
{ Repeat statements up to until}
Repeat

   { Ask the user to enter a date }
   Write('Please enter day: ');
   ReadLn(day);
   Write('Please enter month: ');
   ReadLn(month);
   Write('Please enter year: ');
   ReadLn(year);

   { Year must be positive }
   valid_year := ( year >= 0 );

   { If year is valid, we can proceed to test month }
   If valid_year Then
      Begin

      { Month must be between 1 and 12 }
      valid_month := ( month >= 1 ) and ( month <= 12 );

      { If month is valid, we can proceed to test day }
      If valid_month Then
         Begin

         { Day must be checked against month }
         Case month Of

            { September, April, June and November }
            9, 4, 6, 11:
               Begin
               valid_day := ( day >= 1 ) and ( day <= 30 );
               End;

            { January, March, May, July, August, October, December }
            1, 3, 5, 7..8, 10, 12:
               Begin
               valid_day := ( day >= 1 ) and ( day <= 31 );
               End;

            { February }
            2:
               Begin
               { If year is divisible by 100, it's a century year }
               century_year := ( year mod 100 = 0 ); 

               If century_year Then
                  Begin
                  { Year is leap if divisible by 400 }
                  leap_year := ( year mod 400 = 0 );
                  End
               Else
                  Begin
                  { Year is leap if divisible by 4 }
                  leap_year := ( year mod 4 = 0 );
                  End;

               If leap_year Then
                  Begin
                  { February has 29 days }
                  valid_day := ( day >= 1 ) and ( day <= 29 )
                  End
               Else
                  Begin
                  { February has 28 days }
                  valid_day := ( day >= 1 ) and ( day <= 28 )
                  End

               End

            End { case month... }
          End { if valid_month... }
       End {if valid_year }

   until valid_day and valid_month and valid_year; { Finished if date valid }

WriteLn('Thank you.')
End.
