Program Enum_8_2;
{ Program to find the hottest month, using an enumerated type }
Uses Crt;
Type
   { Enumerated type to represent the months }
   Month = (Jan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec);
   { An array of Real numbers corresponding to each month }
   Weather = Array[Month] of Real;
Const
   { A constant array for converting the enumeration }
   { into a readable string }
   Month_strings: Array[Month] Of String = (
      'January',
      'February',
      'March',
      'April',
      'May',
      'June',
      'July',
      'August',
      'September',
      'October',
      'November',
      'December'
      );
Var
   Temp    : Weather; { An array of temperatures for each month }
   Cmpnent : Month;   { An index into the array }
   Hottest : Real;    { The hottest temperature in the search }
Begin
ClrScr;

{ Read all the temperatures from the user }
For Cmpnent := Jan to Dec do
   Begin
   { Use Month_strings to make the question prettier }
   Write('Enter temperature for ', Month_strings[Cmpnent], ': ');
   ReadLn(Temp[Cmpnent])
   End;

{ Search for the highest temperature }
Hottest := Temp[Jan]; { Initialise Hottest }
For Cmpnent := Feb To Dec Do
   Begin
   If Temp[Cmpnent] > Hottest Then { Replace Hottest if we've found higher }
      Begin
      Hottest := Temp[Cmpnent]
      End
   End;

{ Print result }
WriteLn('Hottest temperature is ', Hottest:5:2);

End.
