Program Car_search;
{ Reads a list of car descriptions and prints the extra }
{ details of the most expensive one }
Uses Crt;
Const
   No_of_cars = 5; { Number of car descriptions }
Type
   Car = Record               { The information for a car }
      Make_model: String;     { The make and model }
      Price, Mpg: Real        { The price and fuel consumption }
      End;
   Car_range = 1..No_of_cars; { A useful integer subrange }
Var
   Cars: Array[Car_range] Of Car; { All the car descriptions }
   Index, High_index: Car_range;  { Working index and index of priciest }
Begin
ClrScr;

{ For every car, fill in the details from the user }
For Index := 1 To No_of_cars Do
   Begin
   WriteLn('Please enter details for car ', Index);
   With Cars[Index] Do  { Avoid some tedious typing }
      Begin
      Write('Make and model: ');
      ReadLn(Make_model);
      Write('Price: ');
      ReadLn(Price);
      Write('Fuel consumption: ');
      ReadLn(Mpg)
      End
   End;

{ Look for the priciest car }
High_index := 1;      { Assume it's the first one }
For Index := 2 To No_of_cars Do
  Begin
  If Cars[Index].Price > Cars[High_index].Price Then { If this one's pricier }
     Begin
     High_index := Index { record its index }
     End
  End;

{ Print the other details of the priciest one }
WriteLn;
With Cars[High_index] Do { Save some more tedious typing }
   Begin
   WriteLn('The most expensive car is the ', Make_model);
   WriteLn('Which has an average fuel consumption of ', Mpg:1:2)
   End
End.
