Program Dialog;
{ As Ex_11_6 but uses a dialog box procedure }
Uses Crt, Dial_sys;
Var
   A : Array[1..6] of String;
   I, No_line : Integer;
   Ch_1, Ch_2 : Char;
   File_Open  : Boolean;
Begin
   {Clear the Screen of any DOS messages}
   Clrscr;
   {Assign the Strings}
   A[1] := '             Create              ';
   A[2] := '             Open                ';
   A[3] := '             Add                 ';
   A[4] := '             Find                ';
   A[5] := '             Amend               ';
   A[6] := '             Exit                ';
   {Draw background window in Blue}
   TextBackground(Blue);
   Window(21,6,58,15);
   Clrscr; {converts background to chosen color}
   {Set the color for the frame and the message}
   TextColor(Red);
   {Draw the frame}
   Rectangle(21,6,58,15);
   {Write the User Message}
   Window(23,7,56,9);
   WriteLn(' Select an action and press Enter');
   For I := 1 to 34 do
      Begin
      Write(Chr(205));
      End;
   {Initialise the variables}
   No_line  := 1;
   File_Open := False;
   Repeat
     Repeat
     {Write the menu}
     Dialog_box;
     Writeln(A[1]);
     Writeln(A[2]);
     Writeln(A[3]);
     Writeln(A[4]);
     Writeln(A[5]);
     Write(A[6]);
     {Draw the Highlight bar}
     TextBackground(Green);
     TextColor(White + Blink);
     Window(23, 8 + No_Line, 56, 8 + No_line);
     Write    (A[No_line]);
     Window(23, 8 + No_Line, 56, 8 + No_line);
     {Test which key pressed and move the bar accordingly}
     Ch_1:= Readkey;
     If Ord(Ch_1) = 0
       Then
       Begin
         Ch_2 := Readkey;
         If Ord(Ch_2) = 80
           Then
             Begin
             {Down key pressed so increase No_line by 1}
             No_line := No_line + 1;
             If (File_Open = false)
             Then
               {if File_Open is false restrict bar to Open, Create and Exit}
               Begin
                 {Check if now bar would move down past "Open"}
                 If No_line > 2
                 Then
                 Begin
                 {Check if now bar would move down past "Exit"}
                   If No_line > 6
                     Then
                     Begin
                     {If yes to both questions move bar to "Create"}
                     No_line := 1;
                     End
                   Else
                     Begin
                     {If yes to first and no to second move bar to "Exit"}
                     No_line := 6;
                     End
                 End
               End
             Else
               {Otherwise If File_Open is true}
               Begin
                 {When bar is to go beyond "Exit" put back to "Add"}
                 If No_line > 6
                 Then
                   Begin
                   No_line := 3;
                   End;
               End;
             End
          Else
            If Ord(Ch_2) = 72
            Then
              Begin
              {Up key pressed so decrease No_Line by one}
              No_line := No_line - 1;
              If (File_Open = false)
              Then
                {if File_Open is false restrict bar to Open, Create and Exit}
                Begin
                {Check if bar would move up past "Create"}
                  If (No_line < 1)
                    Then
                      Begin
                      {If yes move bar to "Exit"}
                      No_line := 6;
                      End
                    Else
                      Begin
                      {If no check if bar would move up above "Exit"}
                        If (No_line < 6) and (No_line > 2)
                          Then
                            Begin
                            {If yes move bar to "Open"}
                            No_line := 2;
                            End
                      End
                End
             Else
             {Otherwise If File_Open is true}
                Begin
                {When bar is to go beyond "Exit" put back to "Add"}
                  If No_line > 6
                    Then
                      Begin
                      No_line := 3;
                      End
                    Else
                     {When bar is to go above "Add" put back to "Exit"}
                     If No_line < 3
                       Then
                         Begin
                         No_line := 6;
                         End
                End
              End
          End
     Until (Ord(Ch_1) = 13);
     {From position of bar select action}
     Case No_line of
            1 : Begin
                Create;
                End;
            2 : Begin
                Open(File_Open);
                If File_Open
                  Then
                    Begin
                    No_line := 3;
                    End
                  Else
                    Begin
                    No_line := 1;
                    End
                End;
            3 : Begin
                Add;
                End;
            4 : Begin
                Find;
                End;
            5 : Begin
                Amend;
                End;
            6 : Begin
                  If File_Open
                  Then
                    Begin
                    Close(My_file);
                    End;
                End;
    End;{Case}
  Until No_line = 6;
  Window(1,1,80,25);
  Clrscr;
End.
