

Program Ex_5_6; { Calculates how much rice you'll get if you ask for one }
                { grain on the first square of a chess board, two on the }
                { second, four on the third, ... }
Uses Crt;
Const
   grains_per_gram = 100;       { Estimate of grains in 1 gram of rice }
                                { (for calculating the total weight) }
Var
   square: Integer;                { Current square (index of the for loop) }
   grains_on_square, total: Real;  { Number of grains on current square }
                                   { and total }
Begin
Clrscr;

{ Initialize variables }
total := 0;		{ Initially no grains }
grains_on_square := 1;  { There's 1 grain on the first square }

{ Do statements between begin...end for every square on the board }
For square := 1 to 8 * 8 Do

   Begin
   total := total + grains_on_square;        { Calculate new total }
   grains_on_square := grains_on_square * 2; { Calculate grains on next square }
   End; { For. Go back to the For statement }

{ Print the result }
WriteLn('You will be paid approximately ', total:20:0, ' grains of rice,');
WriteLn('which is about ',
        round(total/grains_per_gram/1000000/1000000/1000):3,
        ' thousand million tons!');

End.


