Unit My_sys;

Interface

Uses Crt;

Type Rec_type = Record
                   Name             : String;
                   Date_of_birth    : String;
                   Telephone_number : String;
                End;
Var
   My_file       : File of Rec_type;
   External_name : String;
   Rec_var       : Rec_type;

Procedure Rectangle(Left_Col,Top_Row,Right_Col,Btm_Row : Integer);
Procedure Create;
Procedure Open;
Procedure Add;
Procedure Find;
Procedure Amend;

Implementation

Procedure Rectangle(Left_Col,Top_Row,Right_Col,Btm_Row : Integer);
Var
   I, J : Integer;
Begin
{Draw the space and the corner piece}
   Write(' ');
   Write(Chr(201));
{Draw the top line}
   For I := (Left_Col + 2) to (Right_Col - 2) do
      Begin
      Write(Chr(205));
      End;
{Draw corner piece and move to next line}
   WriteLn(Chr(187));
{From the top to the bottom}
   For I := (Top_Row +1) to (Btm_Row - 1) do
   Begin
{Draw the space and then the lines}
      Write(' ');
      Write(Chr(186));
{Draw the spaces in the middle}
      For J := (Left_Col + 2) to (Right_Col - 2) do
         Begin
         Write(' ');
         End;
      WriteLn(Chr(186));
   End;
{Draw the bottom line}
   Write(' ');
   Write(Chr(200));
   For I := (Left_Col + 2) to (Right_Col - 2) do
      Begin
      Write(Chr(205));
      End;
   Write(Chr(188));
End;

Procedure Create;
Var
   Ch : Char;
Begin
   TextBackground(Blue);
   TextColor(Yellow);
   Window(23,9,56,14);
   Clrscr;
   WriteLn('Enter a file name : ');
   ReadLn(External_name);
   Assign(My_file, External_name);
   {$I-}
   Reset(My_file);
   {$I+}
   If IOResult = 0
      Then
         Begin
            TextColor(White+blink);
            WriteLn('File already exists!');
            TextColor(White);
            Writeln('Overwrite? Reply y/n : ');
            Readln(Ch);
            If (Ch = 'y') or (Ch = 'Y')
               Then
                  Begin
                     Rewrite(My_file);
                     Write('DONE! Press a key to continue.');
                     Readkey;
                  End;
         End
      Else
         Begin
            Rewrite(My_file);
            Write('DONE! Press a key to continue.');
            Readkey;
         End;
   TextBackground(Blue);
   TextColor(Yellow);
End;

Procedure Open;
Begin
   TextBackground(Blue);
   TextColor(Yellow);
   Window(23,9,56,14);
   Clrscr;
   WriteLn('Enter a file name : ');
   ReadLn(External_name);
   Assign(My_file, External_name);
   {$I-}
   Reset(My_file);
   {$I+}
   If IOResult <> 0
      Then
         Begin
         TextColor(White+blink);
         WriteLn('Sorry ' , External_name );
         WriteLn('doesn''t exist!');
         WriteLn('You must create it first.');
         WriteLn('Press a key to continue.');
         Readkey;
         End
      Else
         Begin
            Write('DONE! Press a key to continue.');
            Readkey;
         End;
   TextBackground(Blue);
   TextColor(Yellow);
End;

Procedure Add;
Begin
   TextBackground(Blue);
   TextColor(Yellow);
   Window(23,9,56,14);
   Clrscr;
   Seek(My_file, FileSize(My_file));
   Writeln('Enter a name:');
   ReadLn(Rec_var.Name);
   Writeln('Enter a date of birth:');
   ReadLn(Rec_var.Date_of_birth);
   Writeln('Enter a telephone number:');
   ReadLn(Rec_var.Telephone_number);
   Write(My_file, Rec_var);
   TextBackground(Blue);
   TextColor(Yellow);
End;

End.
